/****************************************Copyright (c)**************************************************                         
**
**                                 http://www.powermcu.com
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			GLCD.c
** Descriptions:		STM32 FSMC TFT
**						
**------------------------------------------------------------------------------------------------------
** Created by:			AVRman
** Created date:		2011-2-13
** Version:				1.0
** Descriptions:		The original version
**
**------------------------------------------------------------------------------------------------------
** Modified by:			
** Modified date:	
** Version:
** Descriptions:		
********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "GLCD.h" 

/* Private variables ---------------------------------------------------------*/
static uint16_t DeviceCode;

/* Private define ------------------------------------------------------------*/
/* ʹ߷ʽʱַ */
/* ڲͬBANK,ʹòַͬʱлַ */
#define LCD_REG              (*((volatile unsigned short *) 0x60000000)) /* RS = 0 */
#define LCD_RAM              (*((volatile unsigned short *) 0x60100000)) /* RS = 1 */

#define WIDTH       320                 /* Screen Width (in pixels)           */
#define HEIGHT      240                 /* Screen Hight (in pixels)           */

#define LANDSCAPE   1                   /* 1 for landscape, 0 for portrait    */

/*******************************************************************************
* Function Name  : LCD_CtrlLinesConfig
* Description    : Configures LCD Control lines (FSMC Pins) in alternate function
                   Push-Pull mode.
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void LCD_CtrlLinesConfig(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable FSMC, GPIOD, GPIOE and AFIO clocks */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD | RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO, ENABLE);
                        
  /* PE.03(RS),PE.07(D4), PE.08(D5), PE.09(D6), PE.10(D7), PE.11(D8), PE.12(D9),
     PE.13(D10), PE.14(D11), PE.15(D12) */
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_3 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 |
                                 GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | 
                                 GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  /* PD.00(D2), PD.01(D3), PD.04(RD), PD.5(WR), PD.7(CS), PD.8(D13), PD.9(D14),
     PD.10(D15),  PD.14(D0) PD.15(D1) */
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_7 | 
                                 GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 |// GPIO_Pin_11 | 
                                 GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOD, &GPIO_InitStructure);
	
  /* PD.13(LCD Backlight)	*/
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_13 ;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
  GPIO_Init(GPIOD, &GPIO_InitStructure);	
	
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;		
  GPIO_Init(GPIOE, &GPIO_InitStructure);

}

/*******************************************************************************
* Function Name  : LCD_FSMCConfig
* Description    : Configures the Parallel interface (FSMC) for LCD(Parallel mode)
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void LCD_FSMCConfig(void)
{
  FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
  FSMC_NORSRAMTimingInitTypeDef FSMC_NORSRAMTimingInitStructure;
  /* FSMCٶ */
  FSMC_NORSRAMTimingInitStructure.FSMC_AddressSetupTime = 30;  /* ַʱ  */
  FSMC_NORSRAMTimingInitStructure.FSMC_AddressHoldTime = 0;	   
  FSMC_NORSRAMTimingInitStructure.FSMC_DataSetupTime = 30;	   /* ݽʱ  */
  FSMC_NORSRAMTimingInitStructure.FSMC_BusTurnAroundDuration = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_CLKDivision = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_DataLatency = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_AccessMode = FSMC_AccessMode_A;	/* FSMC ģʽ */

  FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;
  FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
  FSMC_NORSRAMInitStructure.FSMC_MemoryType = FSMC_MemoryType_SRAM;
  FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
  FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
  FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
  FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;
  FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
  FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
  FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
  FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait = FSMC_AsynchronousWait_Disable;
  FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
  FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable;
  FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &FSMC_NORSRAMTimingInitStructure;
  FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure); 
  /* FSMCдٶ */
  FSMC_NORSRAMTimingInitStructure.FSMC_AddressSetupTime = 2;   /* ַʱ  */
  FSMC_NORSRAMTimingInitStructure.FSMC_AddressHoldTime = 0;	   
  FSMC_NORSRAMTimingInitStructure.FSMC_DataSetupTime = 2;	   /* ݽʱ  */
  FSMC_NORSRAMTimingInitStructure.FSMC_BusTurnAroundDuration = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_CLKDivision = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_DataLatency = 0x00;
  FSMC_NORSRAMTimingInitStructure.FSMC_AccessMode = FSMC_AccessMode_A;	/* FSMC ģʽ */
  FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &FSMC_NORSRAMTimingInitStructure;	  

  FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure); 

  /* Enable FSMC Bank1_SRAM Bank */
  FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE);  
}


/*******************************************************************************
* Function Name  : LCD_Configuration
* Description    : Configure the LCD Control pins and FSMC Parallel interface
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void LCD_Configuration(void)
{
 /* Configure the LCD Control pins --------------------------------------------*/
  LCD_CtrlLinesConfig();

/* Configure the FSMC Parallel interface -------------------------------------*/
  LCD_FSMCConfig();
}

/*******************************************************************************
* Function Name  : LCD_WriteReg
* Description    : Writes to the selected LCD register.
* Input          : - LCD_Reg: address of the selected register.
*                  - LCD_RegValue: value to write to the selected register.
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static __inline void LCD_WriteReg(uint8_t LCD_Reg,uint16_t LCD_RegValue)
{
  /* Write 16-bit Index, then Write Reg */
  LCD_REG = LCD_Reg;
  /* Write 16-bit Reg */
  LCD_RAM = LCD_RegValue;
}

/*******************************************************************************
* Function Name  : LCD_WriteReg
* Description    : Reads the selected LCD Register.
* Input          : None
* Output         : None
* Return         : LCD Register Value.
* Attention		 : None
*******************************************************************************/
static __inline uint16_t LCD_ReadReg(uint8_t LCD_Reg)
{
  /* Write 16-bit Index (then Read Reg) */
  LCD_REG = LCD_Reg;
  /* Read 16-bit Reg */
  return (LCD_RAM);
}

/*******************************************************************************
* Function Name  : LCD_WriteRAM_Prepare
* Description    : Prepare to write to the LCD RAM.
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_WriteRAM_Prepare(void)
{		  
  LCD_REG = R34;
}

/*******************************************************************************
* Function Name  : LCD_WriteRAM
* Description    : Writes to the LCD RAM.
* Input          : - RGB_Code: the pixel color in RGB mode (5-6-5).
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_WriteRAM(uint16_t RGB_Code)					 
{
  /* Write 16-bit GRAM Reg */
  LCD_RAM = RGB_Code;
}

/*******************************************************************************
* Function Name  : LCD_ReadRAM
* Description    : Reads the LCD RAM.
* Input          : None
* Output         : None
* Return         : LCD RAM Value.
* Attention		 : None
*******************************************************************************/
static __inline uint16_t LCD_ReadRAM(void)
{
  volatile uint16_t dummy; 
  /* Write 16-bit Index (then Read Reg) */
  LCD_REG = R34; /* Select GRAM Reg */
  /* Read 16-bit Reg */
  dummy = LCD_RAM; 
  
  return LCD_RAM;
}

/*******************************************************************************
* Function Name  : LCD_SetCursor
* Description    : Sets the cursor position.
* Input          : - Xpos: specifies the X position.
*                  - Ypos: specifies the Y position. 
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_SetCursor(uint16_t Xpos,uint16_t Ypos)
{
  if(DeviceCode==0x8989)
  {
    LCD_WriteReg(0x004e,Xpos); /* Row */
    LCD_WriteReg(0x004f,Ypos); /* Line */ 
  }
  else if(DeviceCode==0x9919)
  {
    LCD_WriteReg(0x004e,Xpos); /* Row */
    LCD_WriteReg(0x004f,Ypos); /* Line */	
  }
  else
  {
    LCD_WriteReg(0x0020,Xpos); /* Row */
    LCD_WriteReg(0x0021,Ypos); /* Line */
  }
}

/*******************************************************************************
* Function Name  : LCD_Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
static void LCD_Delay(uint16_t nCount)
{
 uint16_t TimingDelay; 
 while(nCount--)
   {
    for(TimingDelay=0;TimingDelay<10000;TimingDelay++);
   }
}
void GLCD_SetWindow (unsigned int x, unsigned int y, unsigned int w, unsigned int h) {
  //unsigned int xe, ye;

  
   #if (LANDSCAPE == 1)
    LCD_WriteReg(0x50, y);                    /* Vertical   GRAM Start Address      */
    LCD_WriteReg(0x51, y+h-1);                /* Vertical   GRAM End   Address (-1) */
    LCD_WriteReg(0x52, x);                    /* Horizontal GRAM Start Address      */
    LCD_WriteReg(0x53, x+w-1);                /* Horizontal GRAM End   Address (-1) */
    LCD_WriteReg(0x20, y);
    LCD_WriteReg(0x21, x);
   #else
    LCD_WriteReg(0x50, x);                    /* Horizontal GRAM Start Address      */
    LCD_WriteReg(0x51, x+w-1);                /* Horizontal GRAM End   Address (-1) */
    LCD_WriteReg(0x52, y);                    /* Vertical   GRAM Start Address      */
    LCD_WriteReg(0x53, y+h-1);                /* Vertical   GRAM End   Address (-1) */
    LCD_WriteReg(0x20, x);
    LCD_WriteReg(0x21, y);
   #endif
  
}

/*******************************************************************************
* Set draw window region to whole screen                                       *
*   Parameter:                                                                 *
*   Return:                                                                    *
*******************************************************************************/

void GLCD_WindowMax (void) {
  GLCD_SetWindow (0, 0, WIDTH, HEIGHT);
}
/*******************************************************************************
* Clear display                                                                *
*   Parameter:      color:    display clearing color                           *
*   Return:                                                                    *
*******************************************************************************/

void GLCD_Clear (unsigned short color) {
  unsigned int i;
	GLCD_WindowMax ();
	 LCD_WriteReg(0x20,0x0000)           ;    //Command Horizontal GRAM Address Set
																						//Address Start 0x0000
   LCD_WriteReg(0x21,0x0000)           ;    //Command Vertical GRAM Address Set
																						//Address Start 0x0000

  //GLCD_WindowMax();
  LCD_WriteRAM_Prepare();

  for(i = 0; i < (WIDTH*HEIGHT); i++)
	{
    LCD_WriteRAM(color);
 	}
}
static void lcdreset_set(int val)
{
	if(val) {
		GPIO_SetBits(GPIOE, GPIO_Pin_2);
	} else {
		GPIO_ResetBits(GPIOE, GPIO_Pin_2);
	}
}

/*******************************************************************************
* Function Name  : LCD_Initializtion
* Description    : Initialize TFT Controller.
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void LCD_Initializtion()
{
  LCD_Configuration();
  LCD_Delay(5);  /* delay 50 ms */		



  lcdreset_init();
	BL_L;
	lcdreset_set(1);
	LCD_Delay(100); 
	lcdreset_set(0);
	LCD_Delay(100);
	lcdreset_set(1);
	LCD_Delay(100);
	    
     LCD_WriteReg(0x00E5,0x8000);
     /* set R00h at 0001h (OSCEN=1)	*/
     LCD_WriteReg(0x0000,0x0001);
     LCD_Delay(5);  /* delay 50 ms */
     LCD_WriteReg(0x00a4, 0x0001);
     LCD_WriteReg(0x0007,0x0000);
     LCD_Delay(5);  /* delay 50 ms */	
	LCD_WriteReg(0x0001, 0x0100); /* set SS and SM bit */
	LCD_WriteReg(0x0002, 0x0700); /* set 1 line inversion */
	LCD_WriteReg(0x0003, 0x1228); /* set GRAM write direction 0x1228 and BGR=1.  0x1030 fr vertikal  ***************** */
	LCD_WriteReg(0x0004, 0x0000); /* Resize register */
	LCD_WriteReg(0x0008, 0x0202); /* set the back porch and front porch */
	LCD_WriteReg(0x0009, 0x0000); /* set non-display area refresh cycle ISC[3:0] */
     /* LCD driver AC setting (R02h) */

#if 0	
  LCD_WriteReg(0x000a, 0x0000); // FMARK function 
	LCD_WriteReg(0x000c, 0x0000); // RGB interface setting 
	LCD_WriteReg(0x000d, 0x0000); // Frame marker Position 
	LCD_WriteReg(0x000f, 0x0000); // RGB interface polarity 
#endif	

/* Power On sequence ---------------------------------------------------------*/
	LCD_WriteReg(0x0007, 0x0101); /* power control 1 BT, AP */
	LCD_WriteReg(0x0017, 0x0001); /* ????? */

	LCD_WriteReg(0x0010, 0x0000); /* SAP, BT[3:0], AP, DSTB, SLP, STB */
	LCD_WriteReg(0x0011, 0x0007); /* DC1[2:0], DC0[2:0], VC[2:0] */
	LCD_WriteReg(0x0012, 0x0000); /* VREG1OUT voltage */
	LCD_WriteReg(0x0013, 0x0000); /* VDV[4:0] for VCOM amplitude */ 
		LCD_Delay(20);  /* delay 200 ms */	
	LCD_WriteReg(0x0010, 0x16B0); /* SAP, BT[3:0], AP, DSTB, SLP, STB */
	LCD_WriteReg(0x0011, 0x0037); /* DC1[2:0], DC0[2:0], VC[2:0] */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0012, 0x013e); /* VREG1OUT voltage */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0013, 0x1a00); /* VDV[4:0] for VCOM amplitude */
	LCD_WriteReg(0x0029, 0x000f); /* VCM[4:0] for VCOMH */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0020, 0x0000); /* GRAM horizontal Address */
	LCD_WriteReg(0x0021, 0x0000); /* GRAM Vertical Address */

/* Set GRAM area -------------------------------------------------------------*/
	LCD_WriteReg(0x0050, 0x0000); /* Horizontal GRAM Start Address */
	LCD_WriteReg(0x0051, 0x013F); /* Horizontal GRAM End Address *******getauscht***********/
	LCD_WriteReg(0x0052, 0x0000); /* Vertical GRAM Start Address */
	LCD_WriteReg(0x0053, 0x00EF); /* Vertical GRAM End Address */
		
	LCD_WriteReg(0x0060, 0x2700); /* Gate Scan Line **********war2700************************/
	LCD_WriteReg(0x0061, 0x0001); /* NDL,VLE, REV */
	LCD_WriteReg(0x006a, 0x0000); /* set scrolling line */

 /* Panel Control -------------------------------------------------------------*/
	LCD_WriteReg(0x0090, 0x0010);
	LCD_WriteReg(0x0092, 0x0000);
	LCD_WriteReg(0x0093, 0x0000);
 #if 0
	LCD_WriteReg(0x0095, 0x0110);
	LCD_WriteReg(0x0097, 0x0000);
	LCD_WriteReg(0x0098, 0x0000);
 #endif

 /* Adjust the Gamma Curve ----------------------------------------------------*/
	LCD_WriteReg(0x0030, 0x0007);
	LCD_WriteReg(0x0031, 0x0403);
	LCD_WriteReg(0x0032, 0x0404);
	LCD_WriteReg(0x0035, 0x0002);
	LCD_WriteReg(0x0036, 0x0707);
	LCD_WriteReg(0x0037, 0x0606);
	LCD_WriteReg(0x0038, 0x0106);
	LCD_WriteReg(0x0039, 0x0007);
	LCD_WriteReg(0x003c, 0x0700);
	LCD_WriteReg(0x003d, 0x0707);
  
 #if 0
 // Partial Display Control ---------------------------------------------------
	LCD_WriteReg(0x0080, 0x0000);
	LCD_WriteReg(0x0081, 0x0000);
	LCD_WriteReg(0x0082, 0x0000);
	LCD_WriteReg(0x0083, 0x0000);
	LCD_WriteReg(0x0084, 0x0000);
	LCD_WriteReg(0x0085, 0x0000);
 #endif

	LCD_WriteReg(0x0007, 0x0173); /* 262K color and display ON */
	
	
		
}
	

void LCD_ExitSleep(void)
{
	//*************Power On sequence ******************//
	LCD_WriteReg(0x0010, 0x0000); /* SAP, BT[3:0], AP, DSTB, SLP, STB */
	LCD_WriteReg(0x0011, 0x0000); /* DC1[2:0], DC0[2:0], VC[2:0] */
	LCD_WriteReg(0x0012, 0x0000); /* VREG1OUT voltage */
	LCD_WriteReg(0x0013, 0x0000); /* VDV[4:0] for VCOM amplitude */
	LCD_Delay(20);  /* delay 200 ms  Dis-charge capacitor power voltage */
	LCD_WriteReg(0x0010, 0x17B0); /* SAP, BT[3:0], AP, DSTB, SLP, STB */
	LCD_WriteReg(0x0011, 0x0147); /* DC1[2:0], DC0[2:0], VC[2:0] */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0012, 0x013C); /* VREG1OUT voltage */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0013, 0x0E00); /* VDV[4:0] for VCOM amplitude */
	LCD_WriteReg(0x0029, 0x0009); /* VCM[4:0] for VCOMH */
	LCD_Delay(5);  /* delay 50 ms */
	LCD_WriteReg(0x0007, 0x0173); /* 262K color and display ON */
}
void LCD_EnterSleep(void)
{
	LCD_WriteReg(0x0007, 0x0000); /* display OFF */
	//************* Power OFF sequence **************//
	LCD_WriteReg(0x0010, 0x0000); /* SAP, BT[3:0], APE, AP, DSTB, SLP */
	LCD_WriteReg(0x0011, 0x0000); /* DC1[2:0], DC0[2:0], VC[2:0] */
	LCD_WriteReg(0x0012, 0x0000); /* VREG1OUT voltage */
	LCD_WriteReg(0x0013, 0x0000); /* VDV[4:0] for VCOM amplitude */
	LCD_Delay(20);  /* delay 200 ms Dis-charge capacitor power voltage */
	LCD_WriteReg(0x0010, 0x0002); /* SAP, BT[3:0], APE, AP, DSTB, SLP */
}
static void lcdreset_init(void)
{
  GPIO_InitTypeDef GPIO_InitStructure; 

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_Init(GPIOE, &GPIO_InitStructure); 
  
  lcdreset_set(1);
}


/*********************************************************************************************************
      END FILE
*********************************************************************************************************/

